# ---------------------------------
# Finds module TCPTagging
# Adds library to target
# Adds include path
# ---------------------------------

GET_PROPERTY(OV_PRINTED GLOBAL PROPERTY OV_TRIED_OpenViBEModuleTCPTagging)

OPTION(DYNAMIC_LINK_OPENVIBE_MODULE_TCPTAGGING "Dynamically link OpenViBE module TCPTagging" ON)

IF(DYNAMIC_LINK_OPENVIBE_MODULE_TCPTAGGING)
	SET(OPENVIBE_MODULE_TCPTAGGING_LINKING "")
ELSE(DYNAMIC_LINK_OPENVIBE_MODULE_TCPTAGGING)
	SET(OPENVIBE_MODULE_TCPTAGGING_LINKING "-static")
ENDIF(DYNAMIC_LINK_OPENVIBE_MODULE_TCPTAGGING)

set(SRC_DIR ${OV_BASE_DIR}/modules/tcptagging/include)

FIND_PATH(PATH_OPENVIBE_MODULES_TCPTAGGING tcptagging/defines.h PATHS ${SRC_DIR} NO_DEFAULT_PATH)
IF(PATH_OPENVIBE_MODULES_TCPTAGGING)
	OV_PRINT(OV_PRINTED "  Found OpenViBE module TCPTagging...      ${PATH_OPENVIBE_MODULES_TCPTAGGING}")
	INCLUDE_DIRECTORIES(${PATH_OPENVIBE_MODULES_TCPTAGGING}/)

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} openvibe-module-tcptagging${OPENVIBE_MODULE_TCPTAGGING_LINKING})

	ADD_DEFINITIONS(-DTARGET_HAS_TCPTagging)
ELSE(PATH_OPENVIBE_MODULES_TCPTAGGING)
	OV_PRINT(OV_PRINTED "  FAILED to find OpenViBE module TCPTagging...")
ENDIF(PATH_OPENVIBE_MODULES_TCPTAGGING)

SET_PROPERTY(GLOBAL PROPERTY OV_TRIED_OpenViBEModuleTCPTagging "Yes")

