# ---------------------------------
# Finds third party libs for NeuroServo driver
# Adds library to target
# Adds include path
# ---------------------------------

GET_PROPERTY(OV_PRINTED GLOBAL PROPERTY OV_TRIED_ThirdPartyNeuroServoDeps)

IF(WIN32)
	
	FIND_LIBRARY(LIB_STANDARD_MODULE_HID hid)
	FIND_LIBRARY(LIB_STANDARD_MODULE_SETUPAPI SetupApi)

	IF(LIB_STANDARD_MODULE_HID AND LIB_STANDARD_MODULE_SETUPAPI)
		OV_PRINT(OV_PRINTED "  Found NeuroServo driver dependencies ...")
		TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIB_STANDARD_MODULE_HID})
		TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIB_STANDARD_MODULE_SETUPAPI})
		ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyNeuroServo)
	ELSE(LIB_STANDARD_MODULE_HID AND LIB_STANDARD_MODULE_SETUPAPI)
		OV_PRINT(OV_PRINTED "  FAILED to find NeuroServo HID driver dependencies (optional driver) ...")
	ENDIF(LIB_STANDARD_MODULE_HID AND LIB_STANDARD_MODULE_SETUPAPI)
	
	IF(LIB_STANDARD_MODULE_HID)
		OV_PRINT(OV_PRINTED "    [  OK  ] HID library ${LIB_STANDARD_MODULE_HID}...")
	ELSE(LIB_STANDARD_MODULE_HID)
		OV_PRINT(OV_PRINTED "    [FAILED] to find HID library...")
	ENDIF(LIB_STANDARD_MODULE_HID)
	
	IF(LIB_STANDARD_MODULE_SETUPAPI)
		OV_PRINT(OV_PRINTED "    [  OK  ] SetupApi library ${LIB_STANDARD_MODULE_SETUPAPI}...")
	ELSE(LIB_STANDARD_MODULE_SETUPAPI)
		OV_PRINT(OV_PRINTED "    [FAILED] to find SetupApi library...")
	ENDIF(LIB_STANDARD_MODULE_SETUPAPI)


ENDIF(WIN32)


SET_PROPERTY(GLOBAL PROPERTY OV_TRIED_ThirdPartyNeuroServoDeps "Yes")

