# ---------------------------------
# Finds TVicPort toolkit
#
# Sets TVICPORT_FOUND
# Sets TVICPORT_LIBRARIES
# Sets TVICPORT_LIBRARY_DIRS
# Sets TVICPORT_LDFLAGS
# Sets TVICPORT_LDFLAGS_OTHERS
# Sets TVICPORT_INCLUDE_DIRS
# Sets TVICPORT_CFLAGS
# Sets TVICPORT_CFLAGS_OTHERS
# ---------------------------------

IF(WIN32)
	SET(TVICPORT_tvicport_INCLUDE_PATH "TVICPORT_tvicport_INCLUDE_PATH-NOTFOUND")
	
	FIND_PATH(TVICPORT_tvicport_INCLUDE_PATH "TVicPort.h"
		PATHS "${LIST_DEPENDENCIES_PATH}/tvicport/include")
	
	# FIND_LIBRARY(TVICPORT_tvicport_LIBRARY
	#	NAMES TVicPort
	#	PATHS "${LIST_DEPENDENCIES_PATH}/tvicport/libs")
ENDIF(WIN32)

IF(TVICPORT_tvicport_INCLUDE_PATH)
	IF(TVICPORT_tvicport_LIBRARY)
		SET(TVICPORT_FOUND TRUE)
		#SET(TVICPORT_LIBRARIES ${TVICPORT_tvicport_LIBRARY})
		#SET(TVICPORT_LIBRARY_DIRS "")
		SET(TVICPORT_LDFLAGS "")
		SET(TVICPORT_LDFLAGS_OTHERS "")
		SET(TVICPORT_INCLUDE_DIRS ${TVICPORT_tvicport_INCLUDE_PATH})
		SET(TVICPORT_CFLAGS "")
		SET(TVICPORT_CFLAGS_OTHERS "")
	ENDIF(TVICPORT_tvicport_LIBRARY)
ENDIF(TVICPORT_tvicport_INCLUDE_PATH)

MARK_AS_ADVANCED(
	TVICPORT_tvicport_INCLUDE_PATH
	TVICPORT_tvicport_LIBRARY

	TVICPORT_FOUND
	#TVICPORT_LIBRARIES
	#TVICPORT_LIBRARY_DIRS
	TVICPORT_LDFLAGS
	TVICPORT_LDFLAGS_OTHERS
	TVICPORT_INCLUDE_DIRS
	TVICPORT_CFLAGS
	TVICPORT_CFLAGS_OTHERS
)

IF(TVICPORT_FOUND)
	debug_message( "  Found TVicPort...")
	INCLUDE_DIRECTORIES(${TVICPORT_INCLUDE_DIRS})
	ADD_DEFINITIONS(${TVICPORT_CFLAGS})
	ADD_DEFINITIONS(${TVICPORT_CFLAGS_OTHERS})
	# LINK_DIRECTORIES(${EXPAT_LIBRARY_DIRS})
	#ARGET_LINK_LIBRARIES(${PROJECT_NAME} ${TVICPORT_LIBRARIES})

	ADD_DEFINITIONS(-DTARGET_HAS_ThirdPartyTVicPort)
ELSE(TVICPORT_FOUND)
	MESSAGE(WARNING "  FAILED to find TVicPort...")
ENDIF(TVICPORT_FOUND)
